// Ver manual das funções em:
// http://www.box2d.org/manual.html
// http://jbox2d.nfshost.com/processing/doc/index.html


// Bug! 
// Ver: http://processing.org/discourse/yabb2/YaBB.pl?num=1213404906/15
//import org.jbox2d.testbed.tests.*;
//import org.jbox2d.util.blob.*;
//import org.jbox2d.testbed.timingTests.*;
import org.jbox2d.testbed.*;
import org.jbox2d.dynamics.contacts.*;
import org.jbox2d.p5.*;
import org.jbox2d.dynamics.*;
import org.jbox2d.common.*;

import org.jbox2d.collision.*;

import org.jbox2d.dynamics.joints.*;

Physics physics;
void setup() {
  // Inicializa a tela
  size(640,480,P3D);
  // Cria a engine de física (o mundo)
  // escala: 10 pixels = 1 metro
  physics = new Physics(this, width, height);
 
}

void draw() {
   background(0);
}

// MousePressed é chamado quando o botão do mouse é pressionado
void mousePressed() {
  // Dá uma densidade aos corpos criados
    physics.setDensity(1.0f);
    //Cria um corpo (círculo) na posição do mouse
    float x0 = mouseX;
    float y0 = mouseY;
    Body randomBod = physics.createCircle(x0, y0, random(5.0f,15f));
    // Atribui uma velocidade em x e em y para o corpo
    Vec2 vel = new Vec2(random(-30.0f,30.0f),random(-30.0f,30.0f));
    randomBod.setLinearVelocity(vel);
  
}

// KeyPressed é chamado quando qualquer tecla é pressionada
void keyPressed() {
   // Dá uma densidade 0 aos corpos criados a partir deste ponto.
   // Corpos com densidade 0 são estáticos (parados)
    physics.setDensity(0);
    //Cria um corpo na posição do mouse
    float x0 = mouseX;
    float y0 = mouseY;
    Body randomBod = physics.createRect(x0, y0, x0+random(10, 20), y0+random(10,20) );
    // Atribui uma velocidade em x e em y para o corpo
    Vec2 vel = new Vec2(random(-30.0f,30.0f),random(-30.0f,30.0f));
    randomBod.setLinearVelocity(vel); 
}
